/* --------------------------------------------------------
   ԓIȃobt@g
   lp`邩ǂmF

                                     2004/1/14
                                         S.Mio
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -------------------------------------------------------- */
/* lp``p\ */
typedef struct {
    int left;
    int top;
    int width;
    int height;
} t_rect;

/* lp`̔rf[^ */
#define RECTARRAYLIMIT  (32)
t_rect rectarray[RECTARRAYLIMIT] = {
    {76,  3, 17, 31},
    { 6, 83, 23, 16},
    {59, 54, 13, 10},
    {59, 41, 13, 26},
    {71, 10, 32, 11},
    {47, 57, 28, 10},
    {20, 21,  6, 27},
    {49, 10, 31, 13},
    { 0, 12, 15, 19},
    {77, 82,  6, 23},
    {16, 50, 18,  9},
    {55,  7, 29, 32},
    { 2, 22, 23, 27},
    {80,  7, 20, 17},
    {73, 67, 29, 10},
    {80, 41, 19, 11},
    {78, 42, 17, 31},
    {48, 56,  9, 14},
    {31,  3,  7,  9},
    {19, 10, 12, 14},
    { 7,  2,  4, 11},
    {37, 77, 25,  9},
    {37, 41, 15, 16},
    {19, 28, 29, 22},
    { 6, 45, 20,  6},
    {13, 40,  6,  6},
    {29, 33, 10, 29},
    { 1, 21, 11, 15},
    {24, 37, 10,  5},
    {71, 11,  9, 14},
    {22, 65, 33, 15},
    {32,  4,  7, 26},
};

/* lp`̔rf[^ */
t_rect rectsrc = {8, 16, 10, 12};

/* lp`͈ */
#define AREAWIDTH  (100)
#define AREAHEIGHT (100)


/* -------------------------------------------------------- */
/* Tpz */
#define POS_LEFT  (0)
#define POS_RIGHT (1)
typedef struct midbufitem {
    int x;
    int rectpos;
    int type;
} t_midbufitem;
t_midbufitem midbuf[RECTARRAYLIMIT * 2];
t_midbufitem *midbufsort[RECTARRAYLIMIT * 2];
int midline[AREAWIDTH + 2];

/* item->x̑傫midbufsortitemǉ */
void set_miditem(t_midbufitem *item)
{
    t_midbufitem *backitem, *tmpitem;
    int i;

    backitem = NULL;
    for (i = 0; i < (RECTARRAYLIMIT * 2) - 1; i++) {
        if (midbufsort[i] == NULL) {
            break;
        }
        if (backitem != NULL) {
            tmpitem = midbufsort[i];
            midbufsort[i] = backitem;
            backitem = tmpitem;
        } else if (midbufsort[i]->x > item->x) {
            backitem = midbufsort[i];
            midbufsort[i] = item;
        }
    }
    if (backitem != NULL)
        midbufsort[i] = backitem;
    else
        midbufsort[i] = item;
}

/* Tpz̏ */
void init_midbuf(void)
{
    int i, pos;
    
    /* \[gς݃obt@ */
    for (i = 0; i < RECTARRAYLIMIT * 2; i++)
        midbufsort[i] = NULL;
    
    /* ̍W\[gȂo^ */
    for (i = 0; i < RECTARRAYLIMIT; i++) {
        midbuf[i * 2].rectpos = i;
        midbuf[i * 2].type = POS_LEFT;
        midbuf[i * 2].x = rectarray[i].left;
        set_miditem(&midbuf[i * 2]);

        midbuf[(i * 2) + 1].rectpos = i;
        midbuf[(i * 2) + 1].type = POS_RIGHT;
        midbuf[(i * 2) + 1].x = rectarray[i].left + rectarray[i].width;
        set_miditem(&midbuf[(i * 2) + 1]);
    }

    /* Cobt@ */
    pos = 0;
    for (i = 0; i < AREAWIDTH + 2; i++) {
        while ((midbufsort[pos]->x < i) && 
               (pos < RECTARRAYLIMIT * 2)) {
            pos++;
        }
        midline[i] = pos;
    }
}


/* -------------------------------------------------------- */
/* lp`rectarraył̈ʒuĂobt@ */
char hitrectbuf[RECTARRAYLIMIT];

void init_hitrect(void)
{
    int i;
    
    for (i = 0; i < RECTARRAYLIMIT; i++)
        hitrectbuf[i] = -1;
}


/* -------------------------------------------------------- */
/* lp`𒲂ׂ */
void rectsearch(t_rect *checkrect)
{
    int x, pos, rectpos;

    init_midbuf();
    init_hitrect();

    /* T̂leftleft+width͈̔ */
    pos = midline[checkrect->left];

    while (pos < midline[checkrect->left + checkrect->width + 1]) {
        rectpos = midbufsort[pos]->rectpos;
        if ((rectarray[rectpos].top + rectarray[rectpos].height >= checkrect->top) &&
            (rectarray[rectpos].top <=  checkrect->top + checkrect->height)) {
                hitrectbuf[rectpos] = rectpos;
        }
        pos++;
    }

    if (checkrect->left < AREAWIDTH / 2) {
        pos = 0;
        /* ̍WT */
        while (pos < midline[checkrect->left]) {
            if (midbufsort[pos]->type == POS_LEFT) {
                rectpos = midbufsort[pos]->rectpos;
                if ((rectarray[rectpos].left + rectarray[rectpos].width >=  checkrect->left + checkrect->width) &&
                    (rectarray[rectpos].top + rectarray[rectpos].height >= checkrect->top) &&
                    (rectarray[rectpos].top <=  checkrect->top + checkrect->height)) {
                        hitrectbuf[rectpos] = rectpos;
                }
            }
            pos++;
        }
    } else {
        /* E̍WT */
        pos = midline[checkrect->left + checkrect->width + 1];
        while (pos < RECTARRAYLIMIT * 2) {
            if (midbufsort[pos]->type == POS_RIGHT) {
                rectpos = midbufsort[pos]->rectpos;
                if ((rectarray[rectpos].left < checkrect->left) &&
                    (rectarray[rectpos].top + rectarray[rectpos].height >= checkrect->top) &&
                    (rectarray[rectpos].top <= checkrect->top + checkrect->height)) {
                    hitrectbuf[rectpos] = rectpos;
                }
            }
            pos++;
        }
    }
}


/* -------------------------------------------------------- */
/* Tʂ̕\ */
void resultprint(t_rect *checkrect)
{
    int i, pos;

    printf("orig:  l:%d t:%d w:%d h:%d\n\nT:\n", 
        checkrect->left,
        checkrect->top,
        checkrect->width,
        checkrect->height);
    
    for (i = 0; i < RECTARRAYLIMIT; i++) {
        if (hitrectbuf[i] == -1)
            continue;
        pos = hitrectbuf[i];
        printf("  %2d:  l:%2d t:%2d w:%2d h:%2d\n", 
            pos,
            rectarray[pos].left,
            rectarray[pos].top,
            rectarray[pos].width,
            rectarray[pos].height);
    }
}


/* -------------------------------------------------------- */
int main(void)
{
    rectsearch(&rectsrc);
    resultprint(&rectsrc);
    return 0;
}
