/* --------------------------------------------------------
   4؂ŏdȂlp`T(4)

                                     2004/1/14
                                         S.Mio
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -------------------------------------------------------- */
/* lp``p\ */
typedef struct {
    int left;
    int top;
    int width;
    int height;
} t_rect;

/* lp`̔rf[^ */
#define RECTARRAYLIMIT  (32)
t_rect rectarray[RECTARRAYLIMIT] = {
    {76,  3, 17, 31},
    { 6, 83, 23, 16},
    {59, 54, 13, 10},
    {59, 41, 13, 26},
    {71, 10, 32, 11},
    {47, 57, 28, 10},
    {20, 21,  6, 27},
    {49, 10, 31, 13},
    { 0, 12, 15, 19},
    {77, 82,  6, 23},
    {16, 50, 18,  9},
    {55,  7, 29, 32},
    { 2, 22, 23, 27},
    {80,  7, 20, 17},
    {73, 67, 29, 10},
    {80, 41, 19, 11},
    {78, 42, 17, 31},
    {48, 56,  9, 14},
    {31,  3,  7,  9},
    {19, 10, 12, 14},
    { 7,  2,  4, 11},
    {37, 77, 25,  9},
    {37, 41, 15, 16},
    {19, 28, 29, 22},
    { 6, 45, 20,  6},
    {13, 40,  6,  6},
    {29, 33, 10, 29},
    { 1, 21, 11, 15},
    {24, 37, 10,  5},
    {71, 11,  9, 14},
    {22, 65, 33, 15},
    {32,  4,  7, 26},
};

/* lp`̔rf[^ */
t_rect rectsrc = {8, 16, 10, 12};

/* lp`͈ */
#define AREAWIDTH  (100)
#define AREAHEIGHT (100)


/* -------------------------------------------------------- */
/* Tpz */
#define QUADLIMIT     (512)
#define QUADLEVELMAX  (4)
typedef struct quaditem {
    int top, bottom, left, right;
    int level;
    char rectflag[RECTARRAYLIMIT];
    struct quaditem *next[4];
} t_quaditem;

t_quaditem treebuf[QUADLIMIT];
int treetail;
t_quaditem *root;

/* item̏ */
void init_emptyitem(t_quaditem *item)
{
    int i;
    for (i = 0; i < RECTARRAYLIMIT; i++)
        item->rectflag[i] = 0;
    for (i = 0; i < 4; i++)
        item->next[i] = NULL;
    item->level = 0;
}

/* tree󂢂Ăitem̏ꏊ𓾂 */
t_quaditem *get_emptyitem(void)
{
    int pos;
    pos = treetail;
    treetail++;
    init_emptyitem(&treebuf[pos]);
    return &treebuf[pos];
}

/* treerect̃f[^ǉ */
void set_item(t_quaditem *root, t_rect *rect, int rectpos)
{
    t_quaditem *itemstack[QUADLIMIT];
    t_quaditem *item;
    int itemstackhead, i;
    int half_x, half_y, level;

    /* o_̐ݒ */
    itemstack[0] = root;
    itemstackhead = 1;
    
    /* Tn_̎W */
    while (itemstackhead > 0) {

        /* X^bNitem𓾂 */
        itemstackhead--;
        item = itemstack[itemstackhead];


        /* ܂̗̈悪ulp`̓ɂv  */
        /*uxςvłΒlݒ */
        if (((rect->left <= item->left) &&
             (rect->left + rect->width >= item->right) &&
             (rect->top <= item->top) &&
             (rect->top + rect->height >= item->bottom)) || 
             (item->level >= QUADLEVELMAX)) {
            item->rectflag[rectpos] = 1;
            continue;
        }

        /* ^񒆂̒n_ */
        half_x = item->left + (item->right - item->left) / 2;
        half_y = item->top + (item->bottom - item->top) / 2;

        /* 𒲂ׂ */
        if ((rect->left <= half_x) &&
            (rect->top <= half_y)) {
            if (item->next[0] == NULL) {
                item->next[0] = get_emptyitem();
                item->next[0]->level  = item->level + 1;
                item->next[0]->left   = item->left;
                item->next[0]->top    = item->top;
                item->next[0]->right  = half_x;
                item->next[0]->bottom = half_y;
            }
            itemstack[itemstackhead] = item->next[0];
            itemstackhead++;
        }

        /* E𒲂ׂ */
        if ((rect->left + rect->width >= half_x) &&
            (rect->top <= half_y)) {
            if (item->next[1] == NULL) {
                item->next[1] = get_emptyitem();
                item->next[1]->level  = item->level + 1;
                item->next[1]->left   = half_x;
                item->next[1]->top    = item->top;
                item->next[1]->right  = item->right;
                item->next[1]->bottom = half_y;
            }
            itemstack[itemstackhead] = item->next[1];
            itemstackhead++;
        }

        /* 𒲂ׂ */
        if ((rect->left <= half_x) &&
            (rect->top + rect->height >= half_y)) {
            if (item->next[2] == NULL) {
                item->next[2] = get_emptyitem();
                item->next[2]->level  = item->level + 1;
                item->next[2]->left   = item->left;
                item->next[2]->top    = half_y;
                item->next[2]->right  = half_x;
                item->next[2]->bottom = item->bottom;
            }
            itemstack[itemstackhead] = item->next[2];
            itemstackhead++;
        }

        /* E𒲂ׂ */
        if ((rect->left + rect->width >= half_x) &&
            (rect->top + rect->height >= half_y)) {
            if (item->next[3] == NULL) {
                item->next[3] = get_emptyitem();
                item->next[3]->level  = item->level + 1;
                item->next[3]->left   = half_x;
                item->next[3]->top    = half_y;
                item->next[3]->right  = item->right;
                item->next[3]->bottom = item->bottom;
            }
            itemstack[itemstackhead] = item->next[3];
            itemstackhead++;
        }
    }
}

/* ؂̏ */
void init_tree(void)
{
    int i;

    root = get_emptyitem();
    root->left   = 0;
    root->top    = 0;
    root->right  = AREAWIDTH;
    root->bottom = AREAHEIGHT;

    for (i = 0; i < RECTARRAYLIMIT; i++) {
        set_item(root, &rectarray[i], i);
    }
}

/* -------------------------------------------------------- */
/* rectɃ}b`itemtreeTC*/
/* }b`recẗʒu܂Ƃ߂ĕԂ  */
void search_item(char *buf, t_quaditem *root, t_rect *rect)
{
    t_quaditem *itemstack[QUADLIMIT];
    t_quaditem *item;
    int itemstackhead, i;
    int half_x, half_y;

    /* }b`̂𗭂߂Ăobt@ */
    for (i = 0; i < RECTARRAYLIMIT; i++)
        buf[i] = 0;

    /* o_̐ݒ */
    itemstack[0] = root;
    itemstackhead = 1;
    
    /* Tn_̎W */
    while (itemstackhead > 0) {

        /* X^bNitem𓾂 */
        itemstackhead--;
        item = itemstack[itemstackhead];

        /* ܂̈ʒuɂ̂buf֑ */
        for (i = 0; i < RECTARRAYLIMIT; i++) {
            if (item->rectflag[i])
                buf[i] = 1;
        }

        /* ܂̗̈悪ulp`̓ɂvꍇ */
        if ((rect->left <= item->left) &&
             (rect->left + rect->width >= item->right) &&
             (rect->top <= item->top) &&
             (rect->top + rect->height >= item->bottom)) {

            /* 炳ɉ̕Ώɉ */
            for (i = 0; i < 4; i++) {
                if (item->next[i] != NULL) {
                    itemstack[itemstackhead] = item->next[i];
                    itemstackhead++;
                }
            }
            continue;
        }

        /* ^񒆂̒n_ */
        half_x = item->left + (item->right - item->left) / 2;
        half_y = item->top + (item->bottom - item->top) / 2;

        /* 𒲂ׂ */
        if ((rect->left <= half_x) &&
            (rect->top <= half_y) &&
            (item->next[0] != NULL)) {
            itemstack[itemstackhead] = item->next[0];
            itemstackhead++;
        }

        /* E𒲂ׂ */
        if ((rect->left + rect->width >= half_x) &&
            (rect->top <= half_y) &&
            (item->next[1] != NULL)) {
            itemstack[itemstackhead] = item->next[1];
            itemstackhead++;
        }

        /* 𒲂ׂ */
        if ((rect->left <= half_x) &&
            (rect->top + rect->height >= half_y) &&
            (item->next[2] != NULL)) {
            itemstack[itemstackhead] = item->next[2];
            itemstackhead++;
        }

        /* E𒲂ׂ */
        if ((rect->left + rect->width >= half_x) &&
            (rect->top + rect->height >= half_y) &&
            (item->next[3] != NULL)) {
            itemstack[itemstackhead] = item->next[3];
            itemstackhead++;
        }
    }
}


/* -------------------------------------------------------- */
/* lp`rectarraył̈ʒuĂobt@ */
char hitrectbuf[RECTARRAYLIMIT];
int hitrectpos;


/* -------------------------------------------------------- */
/* lp`𒲂ׂ */
void rectsearch(t_rect *checkrect)
{
    char hitbuf[RECTARRAYLIMIT];
    int i;

    /* ؂̏ */
    init_tree();

    /* ؂T */
    search_item(hitbuf, root, checkrect);
    
    /* T */
    hitrectpos = 0;
    for (i = 0; i < RECTARRAYLIMIT; i++) {
        if (hitbuf[i] != 0) {
            /*  */
            if ((rectarray[i].left + rectarray[i].width >= checkrect->left) &&
                (rectarray[i].left <= checkrect->left + checkrect->width) &&
                (rectarray[i].top + rectarray[i].height >= checkrect->top) &&
                (rectarray[i].top <= checkrect->top + checkrect->height)) {
                hitrectbuf[hitrectpos] = i;
                hitrectpos++;
            }
        }
    }
}


/* -------------------------------------------------------- */
/* Tʂ̕\ */
void resultprint(t_rect *checkrect)
{
    int i, pos;

    printf("orig:  l:%d t:%d w:%d h:%d\n\nT:\n", 
        checkrect->left,
        checkrect->top,
        checkrect->width,
        checkrect->height);
    
    for (i = 0; i < hitrectpos; i++) {
        pos = hitrectbuf[i];
        printf("  %2d:  l:%2d t:%2d w:%2d h:%2d\n", 
            pos,
            rectarray[pos].left,
            rectarray[pos].top,
            rectarray[pos].width,
            rectarray[pos].height);
    }
}


/* -------------------------------------------------------- */
int main(void)
{
    rectsearch(&rectsrc);
    resultprint(&rectsrc);
    return 0;
}
