/* --------------------------------------------------------
   4؂ŏdȂlp`T(܂͕̈Ȃ)

                                     2004/1/14
                                         S.Mio
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* -------------------------------------------------------- */
/* lp``p\ */
typedef struct {
    int left;
    int top;
    int width;
    int height;
} t_rect;

/* lp`̔rf[^ */
#define RECTARRAYLIMIT  (32)
t_rect rectarray[RECTARRAYLIMIT] = {
    {76,  3, 17, 31},
    { 6, 83, 23, 16},
    {59, 54, 13, 10},
    {59, 41, 13, 26},
    {71, 10, 32, 11},
    {47, 57, 28, 10},
    {20, 21,  6, 27},
    {49, 10, 31, 13},
    { 0, 12, 15, 19},
    {77, 82,  6, 23},
    {16, 50, 18,  9},
    {55,  7, 29, 32},
    { 2, 22, 23, 27},
    {80,  7, 20, 17},
    {73, 67, 29, 10},
    {80, 41, 19, 11},
    {78, 42, 17, 31},
    {48, 56,  9, 14},
    {31,  3,  7,  9},
    {19, 10, 12, 14},
    { 7,  2,  4, 11},
    {37, 77, 25,  9},
    {37, 41, 15, 16},
    {19, 28, 29, 22},
    { 6, 45, 20,  6},
    {13, 40,  6,  6},
    {29, 33, 10, 29},
    { 1, 21, 11, 15},
    {24, 37, 10,  5},
    {71, 11,  9, 14},
    {22, 65, 33, 15},
    {32,  4,  7, 26},
};

/* lp`̔rf[^ */
t_rect rectsrc = {8, 16, 10, 12};

/* lp`͈ */
#define AREAWIDTH  (100)
#define AREAHEIGHT (100)


/* -------------------------------------------------------- */
/* Tpz */
#define QUADLIMIT     (256)
#define QUADLEVELMAX  (4)
typedef struct quaditem {
    int p1, p2;
    int level;
    char rectflag[RECTARRAYLIMIT];
    struct quaditem *low, *high;
} t_quaditem;

t_quaditem treebuf[QUADLIMIT];
int treetail;
t_quaditem *xroot, *yroot;

/* item̏ */
void init_emptyitem(t_quaditem *item)
{
    int i;

    for (i = 0; i < RECTARRAYLIMIT; i++)
        item->rectflag[i] = 0;
    item->low = NULL;
    item->high = NULL;
}

/* tree󂢂Ăitem̏ꏊ𓾂 */
t_quaditem *get_emptyitem(void)
{
    int pos;
    pos = treetail;
    treetail++;
    init_emptyitem(&treebuf[pos]);
    return &treebuf[pos];
}

/* treerectǉłitemԂ */
t_quaditem *get_item(t_quaditem *root, int rectp1, int rectp2)
{
    t_quaditem *item;
    int halfp, level;

    /* o_̐ݒ */
    item = root;

    /* TQUADLEVELMAX܂ōs */
    for (level = 0; level < QUADLEVELMAX; level++) {
        /* ^񒆂̒n_ */
        halfp = item->p1 + (item->p2 - item->p1) / 2;
        
        /* lȂق(㑤) */
        if ((rectp1 >= item->p1) &&
            (rectp2 <= halfp)) {
            if (item->low == NULL)
                item->low = get_emptyitem();
            item->low->p1 = item->p1;
            item->low->p2 = halfp;
            item = item->low;
            continue;
        }
        
        /* l傫ق(E) */
        if ((rectp1 >= halfp) &&
            (rectp2 <= item->p2)) {
            if (item->high == NULL)
                item->high = get_emptyitem();
            item->high->p1 = halfp;
            item->high->p2 = item->p2;
            item = item->high;
            continue;
        }
        
        /* ǂςȂ炢܂itemԂ */
        return item;
    }
    /* xɒB炢܂itemԂ */
    return item;
}

/* quadtreerectǉ */
void add_rect(t_rect *rect, int rectpos)
{
    t_quaditem *item;

    /* ̒T */
    item = get_item(xroot, rect->left, rect->left + rect->width);
    item->rectflag[rectpos] = 1;

    /* c̒T */
    item = get_item(yroot, rect->top, rect->top + rect->height);
    item->rectflag[rectpos] = 1;
}

/* ؂̏ */
void init_tree(void)
{
    int i;

    xroot = get_emptyitem();
    xroot->p1 = 0;
    xroot->p2 = AREAWIDTH;
    yroot = get_emptyitem();
    yroot->p1 = 0;
    yroot->p2 = AREAHEIGHT;

    for (i = 0; i < RECTARRAYLIMIT; i++) {
        add_rect(&rectarray[i], i);
    }
}

/* -------------------------------------------------------- */
/* rectɃ}b`itemtreeTC*/
/* }b`recẗʒu܂Ƃ߂ĕԂ  */
void search_item(char *buf, t_quaditem *root, int rectp1, int rectp2)
{
    t_quaditem *itemstack[QUADLIMIT];
    t_quaditem *item;
    int itemstackhead, i;

    /* }b`̂𗭂߂Ăobt@ */
    for (i = 0; i < RECTARRAYLIMIT; i++)
        buf[i] = 0;

    /* o_̐ݒ */
    itemstack[0] = root;
    itemstackhead = 1;

    /* Tn_̎W */
    while (itemstackhead > 0) {

        /* X^bNitem𓾂 */
        itemstackhead--;
        item = itemstack[itemstackhead];
        
        /* ܂̈ʒuɂ̂buf֑ */
        for (i = 0; i < RECTARRAYLIMIT; i++) {
            if (item->rectflag[i])
                buf[i] = 1;
        }

        /* Ƃ͂ݏoƂC炳ɉ̕Ή */
        if (item->low != NULL && rectp1 <= item->low->p2) {
            itemstack[itemstackhead] = item->low;
            itemstackhead++;
        }
        if (item->high != NULL && rectp2 >= item->high->p1) {
            itemstack[itemstackhead] = item->high;
            itemstackhead++;
        }
    }
}


/* -------------------------------------------------------- */
/* lp`rectarraył̈ʒuĂobt@ */
char hitrectbuf[RECTARRAYLIMIT];
int hitrectpos;


/* -------------------------------------------------------- */
/* lp`𒲂ׂ */
void rectsearch(t_rect *checkrect)
{
    char hit_xbuf[RECTARRAYLIMIT];
    char hit_ybuf[RECTARRAYLIMIT];
    int i;

    /* ؂̏ */
    init_tree();

    /* ؂T() */
    search_item(hit_xbuf, xroot, 
      checkrect->left, checkrect->left + checkrect->width);
    
    /* ؂T(c) */
    search_item(hit_ybuf, yroot, 
      checkrect->top, checkrect->top + checkrect->height);
    
    /* ɂďcɂ̂T */
    hitrectpos = 0;
    for (i = 0; i < RECTARRAYLIMIT; i++) {
        if ((hit_xbuf[i] != 0) && (hit_ybuf[i] != 0)) {
            /*  */
            if ((rectarray[i].left + rectarray[i].width >= checkrect->left) &&
                (rectarray[i].left <= checkrect->left + checkrect->width) &&
                (rectarray[i].top + rectarray[i].height >= checkrect->top) &&
                (rectarray[i].top <= checkrect->top + checkrect->height)) {
                hitrectbuf[hitrectpos] = i;
                hitrectpos++;
            }
        }
    }
}


/* -------------------------------------------------------- */
/* Tʂ̕\ */
void resultprint(t_rect *checkrect)
{
    int i, pos;

    printf("orig:  l:%d t:%d w:%d h:%d\n\nT:\n", 
        checkrect->left,
        checkrect->top,
        checkrect->width,
        checkrect->height);
    
    for (i = 0; i < hitrectpos; i++) {
        pos = hitrectbuf[i];
        printf("  %2d:  l:%2d t:%2d w:%2d h:%2d\n", 
            pos,
            rectarray[pos].left,
            rectarray[pos].top,
            rectarray[pos].width,
            rectarray[pos].height);
    }
}


/* -------------------------------------------------------- */
int main(void)
{
    rectsearch(&rectsrc);
    resultprint(&rectsrc);
    return 0;
}
